/*----------------------------------------------------------------------------
    calories - real-time, networked, cellular automaton simulation

    Copyright (c) 2008 Ge Wang
        All rights reserved.
        http://ccrma.stanford.edu/~ge/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A.
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// name: ca_custom.h
// desc: header file for new, custom cellular automaton classes
//
// author: Ge Wang (ge@ccrma.stanford.edu)
//   date: 2008.2.19
//-----------------------------------------------------------------------------
#ifndef __CA_CUSTOM_H__
#define __CA_CUSTOM_H__


// includes
#include "ca.h"




//-----------------------------------------------------------------------------
// name: struct CA_GOL
// desc: child CA class, implementing Conway's game of life (in 2D or 3D)
//-----------------------------------------------------------------------------
struct CA_GOL : public CA
{
    // do it
    virtual void update( const Cell * current, Cell * next );
};



//-----------------------------------------------------------------------------
// name: struct CA_Cornholio
// desc: child CA class, implementing Cornholio's Game of Bungholio
//-----------------------------------------------------------------------------
struct CA_Cornholio : public CA
{
    // do it
    virtual void update( const Cell * current, Cell * next );
};



//-----------------------------------------------------------------------------
// name: struct CA_BeyonceButtHead
// desc: child CA class, implementing BeyonceButtHead's Game of Bungholio
//-----------------------------------------------------------------------------
struct CA_BeyonceButtHead : public CA
{
    // do it
    virtual void update( const Cell * current, Cell * next );
};




//-----------------------------------------------------------------------------
// name: struct CA_GOB
// desc: child CA class, implementing GOB: combo GOL+Bungholio=GOB
//-----------------------------------------------------------------------------
struct CA_GOB : public CA
{
    // do it
    virtual void update( const Cell * current, Cell * next );
};




#endif
