/*----------------------------------------------------------------------------
    calories - real-time, networked, cellular automaton simulation

    Copyright (c) 2007 Ge Wang
        All rights reserved.
        http://ccrma.stanford.edu/~ge/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A.
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// name: vectors.h
// desc: vectors
//
// author: Ge Wang (ge@ccrma.stanford.edu)
//   date: 2008.1.15
//-----------------------------------------------------------------------------
#ifndef __VECTORS_H__
#define __VECTORS_H__


// OpenGL
#if defined(__PLATFORM_MACOSX__)
  #include <GLUT/glut.h>
  #include <OpenGL/gl.h>
  #include <OpenGL/glu.h>
#else
  #include <GL/glut.h>
  #include <GL/gl.h>
  #include <GL/glu.h>
#endif


//-----------------------------------------------------------------------------
// name: struct Vector3D
// desc: 3-d vector, duh
//-----------------------------------------------------------------------------
struct Vector3D
{
public:
    GLfloat x;
    GLfloat y;
    GLfloat z;

    Vector3D( GLfloat _x = 0, GLfloat _y = 0, GLfloat _z = 0 ) : x(_x), y(_y), z(_z) { }
};




#endif
